-- frmMain.lua
-- written by Habna


function frmMain()
	self = Turbine.UI.Window();
	
	self:SetSize( 24, 24 );
	local screenWidth, screenHeight = Turbine.UI.Display.GetSize()
	local winWidth, winHeight = self:GetSize();
	self:SetPosition( screenWidth - winWidth - 90, screenHeight - winHeight - 40 );
	self:SetVisible( true );

	reloadButton = Turbine.UI.Button();
	reloadButton:SetParent( self );
	reloadButton:SetPosition( 0, 0 );
	reloadButton:SetSize( self:GetWidth(), self:GetHeight() );
	reloadButton:SetBackground( "HabnaPlugins/Resources/reload.tga" );

	reloadButton.Click = function( sender, args )
		Turbine.PluginManager.RefreshAvailablePlugins()
		local loaded_plugins = Turbine.PluginManager.GetLoadedPlugins()
		local foundWidget = false;
		local foundWindow = false;
		local foundWindowWrapper = false;
		local foundWidgetWrapper = false;

		for k,v in pairs(loaded_plugins) do
			if v.Name == "HugeBag (Widget)" then
				foundWidget = true;
			elseif v.Name == "HugeBag (Window)" then
				foundWindow = true;
			elseif v.Name == "HugeBag (Window) Wrapper" then
				foundWindowWrapper = true;
			elseif v.Name == "HugeBag (Widget) Wrapper" then
				foundWidgetWrapper = true;
			end
		end

		if not foundWidgetWrapper then
			if foundWidget then
				Turbine.PluginManager.UnloadScriptState( "HugeBagWid" );
				Turbine.PluginManager.LoadPlugin("HugeBag (Widget)");
				write( "HugeBag Utilities: HugeBag (Widget) was reloaded" );
			end
		else
			write( "HugeBag Utilities: Unable to reload HugeBag (Widget) when his wrapper is loaded" );
		end

		if not foundWindowWrapper then
			if foundWindow then
				Turbine.PluginManager.UnloadScriptState( "HugeBagWin" );
				Turbine.PluginManager.LoadPlugin("HugeBag (Window)");
				write( "HugeBag Utilities: HugeBag (Window) was reloaded" );
			end
		else
			write( "HugeBag Utilities: Unable to reload HugeBag (Window) when his wrapper is loaded" );
		end

		if not foundWidget and not foundWindow and not foundWidgetWrapper and not foundWindowWrapper then
			write( "HugeBag Utilities: Reload aborted, Nothing is loaded" );
		end
	end
end